set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
 
select name n from v$database;
select user u from dual;
set sqlprompt &ns:&us>

set head on
set echo on
set termout on
set trimspool on


spool &ns.subpartitionedtest.log

-- test of tab stats with hists with subpartitioned table

-- from SQL reference manual:

drop table test;

CREATE TABLE test
    (
    owner        varchar2(2000),
    table_name   varchar2(2000),
    time_id        DATE,
    channel_id     CHAR(1)
    ) 
PARTITION BY RANGE (time_id)
SUBPARTITION BY HASH (channel_id)
  (
   PARTITION P1 VALUES LESS THAN (TO_DATE('01-OCT-2000','DD-MON-YYYY'))
     SUBPARTITIONS 2,
   PARTITION P2 VALUES LESS THAN (MAXVALUE)
     SUBPARTITIONS 2)
;


insert /*+append */ into test select owner,table_name,sysdate,
substr(table_name,1,1)
from dba_tables;

commit;

set timing on

execute tab_stats_with_hists('TSWH','TEST',NULL);
execute tab_stats_with_hists('TSWH','TEST','P1');
execute tab_stats_with_hists('TSWH','TEST','P2');

set timing off

select num_rows,to_char(last_analyzed,'YYYY-MM-DD HH24:MI:SS') LA
from user_tables where table_name='TEST';

select partition_name,num_rows,to_char(last_analyzed,'YYYY-MM-DD HH24:MI:SS') LA,
SUBPARTITION_COUNT
from user_tab_partitions 
where table_name='TEST';

select partition_name,subpartition_name,num_rows,to_char(last_analyzed,'YYYY-MM-DD HH24:MI:SS') LA
from user_tab_subpartitions 
where table_name='TEST';

spool off
